SystemOrganization addCategory: #ConfigurationOfPharoLauncher!

Object subclass: #ConfigurationOfPharoLauncher
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPharoLauncher'!

!ConfigurationOfPharoLauncher commentStamp: 'v 2/16/2015 16:54' prior: 0!
A ConfigurationOfPharoLauncher is usefull to configure the launcher

-> Type "ConfigurationOfPharoLauncher loadBleedingEdge" to load the latest versions of the mcz files defined for this project.

-> Type "ConfigurationOfPharoLauncher loadDevelopment" to load the development version defined for this platform.

-> Type "ConfigurationOfPharoLauncher load" to load the stable version defined for this platform (Recommanded to be used on this platform)
!

!ConfigurationOfPharoLauncher class methodsFor: 'development support' stamp: 'DamienCassou 9/14/2014 21:16'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPharoLauncher class methodsFor: 'private' stamp: 'DamienCassou 9/14/2014 21:16'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPharoLauncher class methodsFor: 'private' stamp: 'DamienCassou 9/14/2014 21:16'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPharoLauncher class methodsFor: 'private' stamp: 'DamienCassou 9/14/2014 21:16'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPharoLauncher class methodsFor: 'metacello tool support' stamp: 'DamienCassou 9/14/2014 21:16'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPharoLauncher class methodsFor: 'loading' stamp: 'DamienCassou 9/14/2014 21:16'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPharoLauncher class methodsFor: 'loading' stamp: 'DamienCassou 9/14/2014 21:16'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPharoLauncher class methodsFor: 'loading' stamp: 'DamienCassou 9/14/2014 21:16'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPharoLauncher class methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2014 21:16'!
project

	^self new project! !

!ConfigurationOfPharoLauncher class methodsFor: 'development support' stamp: 'DamienCassou 9/14/2014 21:16'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPharoLauncher methodsFor: 'baselines' stamp: 'DamienCassou 9/14/2014 22:22'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/Pharo/PharoLauncher/main/'.
		spec 
			project: 'XMLParser' with: [
				spec
					className: #ConfigurationOfXMLParser;
					versionString: #'stable';
					loads: #('Core' );
					repository: 'http://smalltalkhub.com/mc/PharoExtras/XMLParser/main/' ];
			project: 'OSProcess' with: [
				spec
					className: #ConfigurationOfOSProcess;
					versionString: #'stable';
					loads: #('Core' );
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'JSON' with: [
				spec
					className: #ConfigurationOfJSON;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/PharoExtras/JSON/main/' ];
			project: 'Ston' with: [
				spec
					className: #ConfigurationOfSton;
					versionString: #'stable';
					repository: 'http://ss3.gemstone.com/ss/STON' ].
		spec 
			package: #'PharoLauncher-Core' with: [
				spec requires: #('XMLParser' 'OSProcess' 'Ston' 'JSON' ). ];
			package: #'PharoLauncher-Spec' with: [
				spec requires: #(#'PharoLauncher-Core' ). ];
			package: #'PharoLauncher-Tests-Core' with: [
				spec requires: #(#'PharoLauncher-Core' ). ]. ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2014 21:16'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfPharoLauncher methodsFor: 'symbolic versions' stamp: 'DamienCassou 4/20/2015 10:02'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfPharoLauncher methodsFor: 'accessing' stamp: 'DamienCassou 9/14/2014 21:16'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPharoLauncher methodsFor: 'symbolic versions' stamp: 'DamienCassou 4/20/2015 10:03'!
stable: spec
	<symbolicVersion: #stable>
	spec for: #'pharo3.x' version: '0.2.6'.
	spec for: #common version: '0.2.7'! !

!ConfigurationOfPharoLauncher methodsFor: 'versions' stamp: 'DamienCassou 9/14/2014 21:23'!
version020: spec
	<version: '0.2.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2.0'.
		spec author: 'DamienCassou'.
		spec timestamp: '9/14/2014 21:23'.
		spec 
			project: 'XMLParser' with: '1.6.5';
			project: 'OSProcess' with: '4.5.8';
			project: 'JSON' with: '1.0';
			project: 'Ston' with: '0.9'.
		spec 
			package: #'PharoLauncher-Core' with: 'PharoLauncher-Core-DamienCassou.63';
			package: #'PharoLauncher-Spec' with: 'PharoLauncher-Spec-TimMackinnon.34';
			package: #'PharoLauncher-Tests-Core' with: 'PharoLauncher-Tests-Core-TimMackinnon.9'. ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'versions' stamp: 'BenComan 9/22/2014 23:50'!
version021: spec
	<version: '0.2.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2.1'.
		spec author: 'BenComan'.
		spec timestamp: '9/22/2014 23:50'.
		spec 
			project: 'XMLParser' with: '1.6.5';
			project: 'OSProcess' with: '4.5.8';
			project: 'JSON' with: '1.0';
			project: 'Ston' with: '0.9'.
		spec 
			package: #'PharoLauncher-Core' with: 'PharoLauncher-Core-NicolaiHess.64';
			package: #'PharoLauncher-Spec' with: 'PharoLauncher-Spec-NicolaiHess.35';
			package: #'PharoLauncher-Tests-Core' with: 'PharoLauncher-Tests-Core-TimMackinnon.9'. ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'versions' stamp: 'DamienCassou 2/11/2015 16:03'!
version022: spec
	<version: '0.2.2' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2.2'.
		spec author: 'DamienCassou'.
		spec timestamp: '2/11/2015 16:03'.
		spec 
			project: 'XMLParser' with: '1.9.0';
			project: 'OSProcess' with: '4.5.12';
			project: 'JSON' with: '1.0';
			project: 'Ston' with: '0.10'.
		spec 
			package: #'PharoLauncher-Core' with: 'PharoLauncher-Core-DamienCassou.68';
			package: #'PharoLauncher-Spec' with: 'PharoLauncher-Spec-DamienCassou.37';
			package: #'PharoLauncher-Tests-Core' with: 'PharoLauncher-Tests-Core-TimMackinnon.9'. ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'versions' stamp: 'DamienCassou 2/13/2015 11:01'!
version023: spec
	<version: '0.2.3' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2.3'.
		spec author: 'DamienCassou'.
		spec timestamp: '2/13/2015 11:01'.
		spec 
			project: 'XMLParser' with: '1.9.0';
			project: 'OSProcess' with: '4.5.12';
			project: 'JSON' with: '1.0';
			project: 'Ston' with: '0.10'.
		spec 
			package: #'PharoLauncher-Core' with: 'PharoLauncher-Core-DamienCassou.68';
			package: #'PharoLauncher-Spec' with: 'PharoLauncher-Spec-DamienCassou.37';
			package: #'PharoLauncher-Tests-Core' with: 'PharoLauncher-Tests-Core-TimMackinnon.9'. ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'versions' stamp: 'DamienCassou 2/13/2015 11:16'!
version024: spec
	<version: '0.2.4' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2.4'.
		spec author: 'DamienCassou'.
		spec timestamp: '2/13/2015 11:15'.
		spec 
			project: 'XMLParser' with: '1.9.0';
			project: 'OSProcess' with: '4.5.12';
			project: 'JSON' with: '1.0';
			project: 'Ston' with: '0.10'.
		spec 
			package: #'PharoLauncher-Core' with: 'PharoLauncher-Core-DamienCassou.69';
			package: #'PharoLauncher-Spec' with: 'PharoLauncher-Spec-DamienCassou.37';
			package: #'PharoLauncher-Tests-Core' with: 'PharoLauncher-Tests-Core-TimMackinnon.9'. ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'versions' stamp: 'TorstenBergmann 4/17/2015 16:33'!
version025: spec
	<version: '0.2.5' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2.5, Pharo5'.
		spec author: 'TorstenBergmann'.
		spec timestamp: '2/13/2015 11:15'.
		spec 
			project: 'XMLParser' with: '1.9.0';
			project: 'OSProcess' with: '4.5.12';
			project: 'JSON' with: '1.0';
			project: 'Ston' with: '0.10'.
		spec 
			package: #'PharoLauncher-Core' with: 'PharoLauncher-Core-TorstenBergmann.72';
			package: #'PharoLauncher-Spec' with: 'PharoLauncher-Spec-TorstenBergmann.38';
			package: #'PharoLauncher-Tests-Core' with: 'PharoLauncher-Tests-Core-TimMackinnon.9'. ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'versions' stamp: 'DamienCassou 4/17/2015 17:17'!
version026: spec
	<version: '0.2.6' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2.6'.
		spec author: 'DamienCassou'.
		spec timestamp: '4/17/2015 17:17'.
		spec 
			project: 'XMLParser' with: '2.3.0';
			project: 'OSProcess' with: '4.5.13';
			project: 'JSON' with: '1.1';
			project: 'Ston' with: '0.12'.
		spec 
			package: #'PharoLauncher-Core' with: 'PharoLauncher-Core-DamienCassou.74';
			package: #'PharoLauncher-Spec' with: 'PharoLauncher-Spec-DamienCassou.40';
			package: #'PharoLauncher-Tests-Core' with: 'PharoLauncher-Tests-Core-TimMackinnon.9'. ].
! !

!ConfigurationOfPharoLauncher methodsFor: 'versions' stamp: 'DamienCassou 4/20/2015 10:02'!
version027: spec
	<version: '0.2.7' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'version 0.2.7'.
		spec author: 'DamienCassou'.
		spec timestamp: '4/20/2015 10:02'.
		spec 
			project: 'XMLParser' with: '2.3.0';
			project: 'OSProcess' with: '4.5.13';
			project: 'JSON' with: '1.1';
			project: 'Ston' with: '0.12'.
		spec 
			package: #'PharoLauncher-Core' with: 'PharoLauncher-Core-DamienCassou.75';
			package: #'PharoLauncher-Spec' with: 'PharoLauncher-Spec-DamienCassou.40';
			package: #'PharoLauncher-Tests-Core' with: 'PharoLauncher-Tests-Core-TimMackinnon.9'. ].
! !
